#include "descriptor/descriptor.h"


int main(void) {

	ITEM	scena;
	ITEM	parete_frontale, parete_dx, pavimento,soffitto;
	ITEM	pianotto, pianotto1, pianotto2, pianotto3, gamba, battiscopa, profilotavolo, base;
	ITEM	attr_tavolo,tavolo, attr_muro;
	ITEM	attr_tasto, attr_tastino, attr_tastini, attr_telecomando;
	ITEM	piri_C, piri_S,tasto_calotta_m, tasto_calotta_M, tasto_volume_M, tasto_volume_m, tasto_ok;
	ITEM	tasti, tastini, tele, tasti_calotta;
	// setting background color
	set_background(0.12,0.28,0.26,TRUE);

	// setting lights
	create_point_light(-5,14,7,1,1,1,1.2,15, "light1");
	create_point_light(-14,3,6,1,1,1,2.0,20, "light2");
	create_distant_light(1,-4,-5,1,1,1,1.0, "light3");

	// attribute definition

	attr_tasto = create_attribute("tasto");
	        set_color (attr_tasto,1,1,0.84,0.21,0.2);
	        set_reflectivity (attr_tasto,0.14,4);
		set_transparency (attr_tasto,0.87,0.83,32,1.06);
	attr_telecomando = create_attribute("tele");
	        set_color (attr_telecomando,1,1,0.84,0.21,0.2);

	attr_tastini = create_attribute("tasto");
	        set_color (attr_tasto,1,1,0.84,0.21,0.2);
	        set_reflectivity (attr_tasto,0.14,4);
		set_transparency (attr_tasto,0.87,0.83,32,1.06);

        attr_tavolo = create_attribute("tavolo");
	        set_color(attr_tavolo,0,0,1,0.7,0.7);
	        set_reflectivity(attr_tavolo,0.15,10);
	attr_muro = create_attribute("muro");
		set_color(attr_muro,1,1,0.88,1,1);

	//  ... loading object
	parete_dx = read_nurbs ("parete_dx.db");
	parete_frontale = read_nurbs ("parete_frontale.db");
	pavimento = read_nurbs ("pavimento.db");
	pianotto= read_nurbs("pianotto.db");
	pianotto1= read_nurbs("pianotto1.db");
	pianotto2= read_nurbs("pianotto2.db");
	pianotto3= read_nurbs("pianotto3.db");
	profilotavolo= read_nurbs("profilotavolo.db");
	base= read_nurbs("base.db");
	gamba= read_nurbs("gamba.db");
	piri_C = read_nurbs("piri_C.db");
	piri_S = read_nurbs("piri_S.db");

	tasto_ok  = read_nurbs("tasto_ok.db");
	tasto_calotta_m  = read_nurbs("tasto_calotta_m.db");
	tasto_calotta_M  = read_nurbs("tasto_calotta_M.db");
	tasto_volume_M = read_nurbs("tasto_volume_M.db");
	tasto_volume_m = read_nurbs("tasto_volume_m.db");

	tele = read_obj("tele.obj","tele");
	tasti = read_obj("tasti.obj","tasti");
	tastini = read_obj("tastini.obj","tastini");

	// ... creating object hierarchy
	scena = create_list (gamba, "scena");
	scena = insert_in_list (scena, pavimento);
	scena = insert_in_list (scena, parete_dx);
	scena = insert_in_list (scena, parete_frontale);
	scena = insert_in_list (scena, base);
	scena = insert_in_list (scena, pianotto);
	scena = insert_in_list (scena, pianotto1);
	scena = insert_in_list (scena, pianotto2);
	scena = insert_in_list (scena, pianotto3);
	scena = insert_in_list (scena, gamba);
	scena = insert_in_list (scena, profilotavolo);
	scena = insert_in_list (scena, tasti);
	scena = insert_in_list (scena, tasto_ok);
	scena = insert_in_list (scena, tastini);
	scena = insert_in_list (scena, tele);
	scena = insert_in_list (scena, piri_C);
	scena = insert_in_list (scena, piri_S);
	scena = insert_in_list (scena,tasto_calotta_m);
	scena = insert_in_list (scena,tasto_calotta_M);
	scena = insert_in_list (scena,tasto_volume_M);
	scena = insert_in_list (scena,tasto_volume_m);

	// Moving some object ...
	set_z_rotate (tele,-35,1);
	set_scale (tele, 0.28, 0.28, 0.28);
	set_translate (tele,0.1,0.1,0.345);

	set_z_rotate (tasti,-35,1);
	set_scale (tasti, 0.28, 0.28, 0.28);
	set_translate (tasti,0.1,0.1,0.343);

	set_z_rotate (tastini,-35,1);
	set_scale (tastini, 0.28, 0.28, 0.28);
	set_translate (tastini,0.1,0.1,0.343);

	set_z_rotate (piri_C,-35,1);
	set_scale (piri_C, 0.28, 0.28, 0.28);
	set_translate (piri_C,0.1,0.1,0.345);

	set_z_rotate (piri_S,-35,1);
	set_scale (piri_S, 0.28, 0.28, 0.28);
	set_translate (piri_S,0.1,0.1,0.345);

	set_z_rotate (tasto_volume_M,-35,1);
	set_scale (tasto_volume_M, 0.28, 0.28, 0.28);
	set_translate (tasto_volume_M,0.1,0.1,0.344);

	set_z_rotate (tasto_volume_m,-35,1);
	set_scale (tasto_volume_m, 0.28, 0.28, 0.28);
	set_translate (tasto_volume_m,0.1,0.1,0.344);

	set_z_rotate (tasto_calotta_m,-35,1);
	set_scale (tasto_calotta_m, 0.28, 0.28, 0.28);
	set_translate (tasto_calotta_m,0.1,0.1,0.348);

	set_z_rotate (tasto_calotta_M,-35,1);
	set_scale (tasto_calotta_M, 0.28, 0.28, 0.28);
	set_translate (tasto_calotta_M,0.1,0.1,0.347);

	set_z_rotate (tasto_ok,-35,1);
	set_scale (tasto_ok, 0.28, 0.28, 0.28);
	set_translate (tasto_ok,0.1,0.1,0.345);

	set_attribute (tele,attr_telecomando);
	set_attribute (pianotto,attr_muro);
	set_attribute (parete_dx,attr_muro);
	set_attribute (parete_frontale,attr_muro);
	set_attribute (pianotto1, attr_tavolo);
	set_attribute (pianotto2, attr_tavolo);
	set_attribute (pianotto3, attr_tavolo);
	set_attribute (gamba, attr_tavolo);
	set_attribute (base, attr_tavolo);
	set_attribute (tasti, attr_tasto);
	set_attribute (tasto_calotta_m, attr_tasto);
	set_attribute (tasto_calotta_M, attr_tasto);
	set_attribute (tasto_volume_m, attr_tasto);
	set_attribute (tasto_volume_M, attr_tasto);
	set_attribute (tastini, attr_tastini);


	// ... Floor's texture
		set_scale (pavimento,0.93,0.93,0.93);
		set_translate (pavimento,-1.01,0.07,0.0);
		set_projection_texture(pavimento,attr_muro,"textures/pavimento.hr",2,1,0.4,0.6);
		set_translate (pavimento,1.01,-0.07,0.0);
		set_scale (pavimento,1.0753,1.0753,1.0753);

	// ... Telecomando texture
		set_scale (tele,0.93,0.93,0.93);
		set_translate (tele,-1.01,0.07,0.0);
	set_projection_texture(tele,attr_telecomando,"textures/telecomando3.hr",2,1,0.4,0.6);
		set_translate (tele,1.01,-0.07,0.0);
		set_scale (tele,1.0753,1.0753,1.0753);

	// ... Table's texture
		set_scale (pianotto,4,4,4);
	set_projection_texture(pianotto,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (pianotto,0.25,0.25,0.25);

		set_scale (pianotto1,4,4,4);
	set_projection_texture(pianotto1,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (pianotto1,0.25,0.25,0.25);

		set_scale (pianotto2,4,4,4);
	set_projection_texture(pianotto2,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (pianotto2,0.25,0.25,0.25);

		set_scale (pianotto3,4,4,4);
	set_projection_texture(pianotto3,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (pianotto3,0.25,0.25,0.25);

		set_scale (profilotavolo,4,4,4);
	set_projection_texture(profilotavolo,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (profilotavolo,0.25,0.25,0.25);

		set_scale (gamba,4,4,4);
	set_projection_texture(gamba,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (gamba,0.25,0.25,0.25);

		set_scale (base,4,4,4);
	set_projection_texture(base,attr_tavolo,"textures/table.hr",2,1,0.4,0.4);
		set_scale (base,0.25,0.25,0.25);


	// ... Wall's texture
		set_scale (parete_frontale,2,2,2);
		set_x_rotate (parete_frontale,90,1);
	set_projection_texture(parete_frontale,attr_muro,"textures/telecomando.hr",2,2,0.4,0.6);
        	set_x_rotate (parete_frontale,-90,1);
		set_scale (parete_frontale,0.5,0.5,0.5);

		set_scale (parete_dx,2,2,2);
		set_y_rotate (parete_dx,90,1);
		set_z_rotate (parete_dx,90,1);
	set_projection_texture(parete_dx,attr_muro,"textures/telecomando.hr",2,3,0.4,0.6);
		set_z_rotate (parete_dx,-90,1);
        	set_y_rotate (parete_dx,-90,1);
		set_scale (parete_dx,0.5,0.5,0.5);

	save_scene("valeria.md","valeria",scena);
	return(0);
}
